#!/bin/sh

set -e

# run filter and type tests
./nftest

# Check for correct output
./nfgen | ./nfdump -q -o extended  > test1.out
diff test1.out nfdump.test.out

./nfgen | ./nfdump -q -w  test.flows
./nfdump -q -r test.flows -o extended > test2.out
diff test2.out nfdump.test.out

rm -r test1.out test2.out

# create tmp dir for flow replay
if [ -d tmp ]; then
	rm -f tmp/*
	rmdir tmp
fi
mkdir tmp

# Start nfcapd on localhost and replay flows
echo
echo -n Starting nfcapd ...
./nfcapd -p 65530 -l tmp -D -P tmp/pidfile
sleep 1
echo done.
echo -n Replay flows ...
./nfreplay -r test.flows -v9 -H 127.0.0.1 -p 65530
echo done.

echo -n Terminate nfcapd ...
kill -TERM `cat tmp/pidfile`;
sleep 1
echo done.

if [ -f tmp/pidfile ]; then
	echo nfcapd does not terminate
	exit
fi

diff test.flows tmp/nfcapd.*

rm test.flows tmp/nfcapd.*
rmdir tmp

echo All tests successful.
